Index: set.c
===================================================================
--- set.c	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ set.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -26,22 +26,21 @@
 #include "bitlbee.h"
 
-set_t *set_add( set_t **head, char *key, char *def, void *eval, void *data )
-{
-	set_t *s = set_find( head, key );
-	
-	/* Possibly the setting already exists. If it doesn't exist yet,
-	   we create it. If it does, we'll just change the default. */
+set_t *set_add( irc_t *irc, char *key, char *def, void *eval )
+{
+	set_t *s = set_find( irc, key );
+	
 	if( !s )
 	{
-		if( ( s = *head ) )
+		if( ( s = irc->set ) )
 		{
 			while( s->next ) s = s->next;
-			s->next = g_new0( set_t, 1 );
+			s->next = g_new ( set_t, 1 );
 			s = s->next;
 		}
 		else
 		{
-			s = *head = g_new0( set_t, 1 );
+			s = irc->set = g_new( set_t, 1 );
 		}
+		memset( s, 0, sizeof( set_t ) );
 		s->key = g_strdup( key );
 	}
@@ -54,13 +53,17 @@
 	if( def ) s->def = g_strdup( def );
 	
-	s->eval = eval;
-	s->data = data;
-	
-	return s;
-}
-
-set_t *set_find( set_t **head, char *key )
-{
-	set_t *s = *head;
+	if( s->eval )
+	{
+		g_free( s->eval );
+		s->eval = NULL;
+	}
+	if( eval ) s->eval = eval;
+	
+	return( s );
+}
+
+set_t *set_find( irc_t *irc, char *key )
+{
+	set_t *s = irc->set;
 	
 	while( s )
@@ -71,54 +74,44 @@
 	}
 	
-	return s;
-}
-
-char *set_getstr( set_t **head, char *key )
-{
-	set_t *s = set_find( head, key );
+	return( s );
+}
+
+char *set_getstr( irc_t *irc, char *key )
+{
+	set_t *s = set_find( irc, key );
 	
 	if( !s || ( !s->value && !s->def ) )
-		return NULL;
-	
-	return s->value ? s->value : s->def;
-}
-
-int set_getint( set_t **head, char *key )
-{
-	char *s = set_getstr( head, key );
+		return( NULL );
+	
+	return( s->value?s->value:s->def );
+}
+
+int set_getint( irc_t *irc, char *key )
+{
+	char *s = set_getstr( irc, key );
 	int i = 0;
 	
 	if( !s )
-		return 0;
+		return( 0 );
 	
 	if( ( g_strcasecmp( s, "true" ) == 0 ) || ( g_strcasecmp( s, "yes" ) == 0 ) || ( g_strcasecmp( s, "on" ) == 0 ) )
-		return 1;
+		return( 1 );
 	
 	if( sscanf( s, "%d", &i ) != 1 )
-		return 0;
-	
-	return i;
-}
-
-int set_getbool( set_t **head, char *key )
-{
-	char *s = set_getstr( head, key );
+		return( 0 );
+	
+	return( i );
+}
+
+int set_setstr( irc_t *irc, char *key, char *value )
+{
+	set_t *s = set_find( irc, key );
+	char *nv = value;
 	
 	if( !s )
-		return 0;
-	
-	return bool2int( s );
-}
-
-int set_setstr( set_t **head, char *key, char *value )
-{
-	set_t *s = set_find( head, key );
-	char *nv = value;
-	
-	if( !s )
-		s = set_add( head, key, NULL, NULL, NULL );
-	
-	if( s->eval && !( nv = s->eval( s, value ) ) )
-		return 0;
+		s = set_add( irc, key, NULL, NULL );
+	
+	if( s->eval && !( nv = s->eval( irc, s, value ) ) )
+		return( 0 );
 	
 	if( s->value )
@@ -128,6 +121,4 @@
 	}
 	
-	/* If there's a default setting and it's equal to what we're trying to
-	   set, stick with s->value = NULL. Otherwise, remember the setting. */
 	if( !s->def || ( strcmp( nv, s->def ) != 0 ) )
 		s->value = g_strdup( nv );
@@ -136,18 +127,18 @@
 		g_free( nv );
 	
-	return 1;
-}
-
-int set_setint( set_t **head, char *key, int value )
+	return( 1 );
+}
+
+int set_setint( irc_t *irc, char *key, int value )
 {
 	char s[24];	/* Not quite 128-bit clean eh? ;-) */
 	
-	g_snprintf( s, sizeof( s ), "%d", value );
-	return set_setstr( head, key, s );
-}
-
-void set_del( set_t **head, char *key )
-{
-	set_t *s = *head, *t = NULL;
+	sprintf( s, "%d", value );
+	return( set_setstr( irc, key, s ) );
+}
+
+void set_del( irc_t *irc, char *key )
+{
+	set_t *s = irc->set, *t = NULL;
 	
 	while( s )
@@ -162,5 +153,5 @@
 			t->next = s->next;
 		else
-			*head = s->next;
+			irc->set = s->next;
 		
 		g_free( s->key );
@@ -171,21 +162,25 @@
 }
 
-char *set_eval_int( set_t *set, char *value )
-{
-	char *s;
-	
-	for( s = value; *s; s ++ )
-		if( !isdigit( *s ) )
-			return NULL;
-	
-	return value;
-}
-
-char *set_eval_bool( set_t *set, char *value )
-{
-	return is_bool( value ) ? value : NULL;
-}
-
-char *set_eval_to_char( set_t *set, char *value )
+char *set_eval_int( irc_t *irc, set_t *set, char *value )
+{
+	char *s = value;
+	
+	for( ; *s; s ++ )
+		if( *s < '0' || *s > '9' )
+			return( NULL );
+	
+	return( value );
+}
+
+char *set_eval_bool( irc_t *irc, set_t *set, char *value )
+{
+	if( ( g_strcasecmp( value, "true" ) == 0 ) || ( g_strcasecmp( value, "yes" ) == 0 ) || ( g_strcasecmp( value, "on" ) == 0 ) )
+		return( value );
+	if( ( g_strcasecmp( value, "false" ) == 0 ) || ( g_strcasecmp( value, "no" ) == 0 ) || ( g_strcasecmp( value, "off" ) == 0 ) )
+		return( value );
+	return( set_eval_int( irc, set, value ) );
+}
+
+char *set_eval_to_char( irc_t *irc, set_t *set, char *value )
 {
 	char *s = g_new( char, 3 );
@@ -196,41 +191,35 @@
 		sprintf( s, "%c ", *value );
 	
-	return s;
-}
-
-char *set_eval_ops( set_t *set, char *value )
-{
-	irc_t *irc = set->data;
-	
+	return( s );
+}
+
+char *set_eval_ops( irc_t *irc, set_t *set, char *value )
+{
 	if( g_strcasecmp( value, "user" ) == 0 )
+	{
 		irc_write( irc, ":%s!%s@%s MODE %s %s %s %s", irc->mynick, irc->mynick, irc->myhost,
 		                                              irc->channel, "+o-o", irc->nick, irc->mynick );
+		return( value );
+	}
 	else if( g_strcasecmp( value, "root" ) == 0 )
+	{
 		irc_write( irc, ":%s!%s@%s MODE %s %s %s %s", irc->mynick, irc->mynick, irc->myhost,
 		                                              irc->channel, "-o+o", irc->nick, irc->mynick );
+		return( value );
+	}
 	else if( g_strcasecmp( value, "both" ) == 0 )
+	{
 		irc_write( irc, ":%s!%s@%s MODE %s %s %s %s", irc->mynick, irc->mynick, irc->myhost,
 		                                              irc->channel, "+oo", irc->nick, irc->mynick );
+		return( value );
+	}
 	else if( g_strcasecmp( value, "none" ) == 0 )
+	{
 		irc_write( irc, ":%s!%s@%s MODE %s %s %s %s", irc->mynick, irc->mynick, irc->myhost,
 		                                              irc->channel, "-oo", irc->nick, irc->mynick );
-	else
-		return NULL;
-	
-	return value;
-}
-
-char *set_eval_charset( set_t *set, char *value )
-{
-	GIConv cd;
-
-	if ( g_strncasecmp( value, "none", 4 ) == 0 )
-		return value;
-
-	cd = g_iconv_open( "UTF-8", value );
-	if( cd == (GIConv) -1 )
-		return NULL;
-
-	g_iconv_close( cd );
-	return value;
-}
+		return( value );
+	}
+	
+	return( NULL );
+}
+
Index: set.h
===================================================================
--- set.h	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ set.h	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -2,5 +2,5 @@
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
-  * Copyright 2002-2006 Wilmer van der Gaast and others                *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
   \********************************************************************/
 
@@ -26,32 +26,27 @@
 typedef struct set
 {
-	void *data;
-	
 	char *key;
 	char *value;
 	char *def;	/* Default */
 	
-	int flags;
-	
-	/* Eval: Returns NULL if the value is incorrect or exactly the
-	   passed value variable. When returning a corrected value,
-	   set_setstr() should be able to free() the returned string! */
-	char *(*eval) ( struct set *set, char *value );
+	/* Eval: Returns NULL if the value is incorrect. Can return a
+	   corrected value. set_setstr() should be able to free() the
+	   returned string! */
+	char *(*eval) ( irc_t *irc, struct set *set, char *value );
 	struct set *next;
 } set_t;
 
-set_t *set_add( set_t **head, char *key, char *def, void *eval, void *data );
-set_t *set_find( set_t **head, char *key );
-G_MODULE_EXPORT char *set_getstr( set_t **head, char *key );
-G_MODULE_EXPORT int set_getint( set_t **head, char *key );
-G_MODULE_EXPORT int set_getbool( set_t **head, char *key );
-int set_setstr( set_t **head, char *key, char *value );
-int set_setint( set_t **head, char *key, int value );
-void set_del( set_t **head, char *key );
+set_t *set_add( irc_t *irc, char *key, char *def, void *eval );
+G_MODULE_EXPORT set_t *set_find( irc_t *irc, char *key );
+G_MODULE_EXPORT char *set_getstr( irc_t *irc, char *key );
+G_MODULE_EXPORT int set_getint( irc_t *irc, char *key );
+int set_setstr( irc_t *irc, char *key, char *value );
+int set_setint( irc_t *irc, char *key, int value );
+void set_del( irc_t *irc, char *key );
 
-char *set_eval_int( set_t *set, char *value );
-char *set_eval_bool( set_t *set, char *value );
+char *set_eval_int( irc_t *irc, set_t *set, char *value );
+char *set_eval_bool( irc_t *irc, set_t *set, char *value );
+char *set_eval_to_char( irc_t *irc, set_t *set, char *value );
+char *set_eval_ops( irc_t *irc, set_t *set, char *value );
 
-char *set_eval_to_char( set_t *set, char *value );
-char *set_eval_ops( set_t *set, char *value );
-char *set_eval_charset( set_t *set, char *value );
+
Index: storage.c
===================================================================
--- storage.c	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ storage.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -6,6 +6,4 @@
 
 /* Support for multiple storage backends */
-
-/* Copyright (C) 2005 Jelmer Vernooij <jelmer@samba.org> */
 
 /*
@@ -31,7 +29,7 @@
 
 extern storage_t storage_text;
-extern storage_t storage_xml;
 
-static GList *storage_backends = NULL;
+static GList text_entry = { &storage_text, NULL, NULL };
+static GList *storage_backends = &text_entry;
 
 void register_storage_backend(storage_t *backend)
@@ -43,5 +41,5 @@
 {
 	GList *gl;
-	storage_t *st = NULL;
+	storage_t *st;
 
 	for (gl = storage_backends; gl; gl = gl->next) {
@@ -65,8 +63,5 @@
 	int i;
 	storage_t *storage;
-	
-	register_storage_backend(&storage_text);
-	register_storage_backend(&storage_xml);
-	
+
 	storage = storage_init_single(primary);
 	if (storage == NULL)
Index: storage_text.c
===================================================================
--- storage_text.c	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ storage_text.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -116,4 +116,10 @@
 	}
 	fclose( fp );
+	
+	if( set_getint( irc, "auto_connect" ) )
+	{
+		strcpy( s, "account on" );	/* Can't do this directly because r_c_s alters the string */
+		root_command_string( irc, ru, s, 0 );
+	}
 	
 	return STORAGE_OK;
Index: unix.c
===================================================================
--- unix.c	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ unix.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -48,16 +48,18 @@
 	
 	b_main_init();
+	
 	log_init();
+
 	nogaim_init();
-	
-	srand( time( NULL ) ^ getpid() );
-	
+
 	CONF_FILE = g_strdup( CONF_FILE_DEF );
+	
 	global.helpfile = g_strdup( HELP_FILE );
-	
+
 	global.conf = conf_load( argc, argv );
 	if( global.conf == NULL )
 		return( 1 );
-	
+
+
 	if( global.conf->runmode == RUNMODE_INETD )
 	{
@@ -87,5 +89,5 @@
 	if( i != 0 )
 		return( i );
-	
+
 	global.storage = storage_init( global.conf->primary_storage, global.conf->migrate_storage );
 	if ( global.storage == NULL) {
Index: url.c
===================================================================
--- url.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
+++ url.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -0,0 +1,107 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2001-2005 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* URL/mirror stuff - Stolen from Axel                                  */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#include "url.h"
+
+/* Convert an URL to a url_t structure					*/
+int url_set( url_t *url, char *set_url )
+{
+	char s[MAX_STRING];
+	char *i;
+	
+	/* protocol://							*/
+	if( ( i = strstr( set_url, "://" ) ) == NULL )
+	{
+		url->proto = PROTO_DEFAULT;
+		strncpy( s, set_url, MAX_STRING );
+	}
+	else
+	{
+		if( g_strncasecmp( set_url, "http", i - set_url ) == 0 )
+			url->proto = PROTO_HTTP;
+		else if( g_strncasecmp( set_url, "https", i - set_url ) == 0 )
+			url->proto = PROTO_HTTPS;
+		else if( g_strncasecmp( set_url, "socks4", i - set_url ) == 0 )
+			url->proto = PROTO_SOCKS4;
+		else if( g_strncasecmp( set_url, "socks5", i - set_url ) == 0 )
+			url->proto = PROTO_SOCKS5;
+		else
+		{
+			return( 0 );
+		}
+		strncpy( s, i + 3, MAX_STRING );
+	}
+	
+	/* Split							*/
+	if( ( i = strchr( s, '/' ) ) == NULL )
+	{
+		strcpy( url->file, "/" );
+	}
+	else
+	{
+		strncpy( url->file, i, MAX_STRING );
+		*i = 0;
+	}
+	strncpy( url->host, s, MAX_STRING );
+	
+	/* Check for username in host field				*/
+	if( strrchr( url->host, '@' ) != NULL )
+	{
+		strncpy( url->user, url->host, MAX_STRING );
+		i = strrchr( url->user, '@' );
+		*i = 0;
+		strcpy( url->host, i + 1 );
+		*url->pass = 0;
+	}
+	/* If not: Fill in defaults					*/
+	else
+	{
+		*url->user = *url->pass = 0;
+	}
+	
+	/* Password?							*/
+	if( ( i = strchr( url->user, ':' ) ) != NULL )
+	{
+		*i = 0;
+		strcpy( url->pass, i + 1 );
+	}
+	/* Port number?							*/
+	if( ( i = strchr( url->host, ':' ) ) != NULL )
+	{
+		*i = 0;
+		sscanf( i + 1, "%d", &url->port );
+	}
+	else
+	{
+		if( url->proto == PROTO_HTTP )
+			url->port = 80;
+		else if( url->proto == PROTO_HTTPS )
+			url->port = 443;
+		else if( url->proto == PROTO_SOCKS4 || url->proto == PROTO_SOCKS4 )
+			url->port = 1080;
+	}
+	
+	return( url->port > 0 );
+}
Index: url.h
===================================================================
--- url.h	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
+++ url.h	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -0,0 +1,44 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2001-2004 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* URL/mirror stuff - Stolen from Axel                                  */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#include "bitlbee.h"
+
+#define PROTO_HTTP		2
+#define PROTO_HTTPS		5
+#define PROTO_SOCKS4	3
+#define PROTO_SOCKS5	4
+#define PROTO_DEFAULT	PROTO_HTTP
+
+typedef struct url
+{
+	int proto;
+	int port;
+	char host[MAX_STRING];
+	char file[MAX_STRING];
+	char user[MAX_STRING];
+	char pass[MAX_STRING];
+} url_t;
+
+int url_set( url_t *url, char *set_url );
Index: user.c
===================================================================
--- user.c	(revision fef6116e89bb0651c72454effbb51e04e9e1b8dc)
+++ user.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -67,5 +67,5 @@
 	
 	u->user = u->realname = u->host = u->nick = g_strdup( nick );
-	u->is_private = set_getint( &irc->set, "private" );
+	u->is_private = set_getint( irc, "private" );
 	
 	key = g_strdup( nick );
@@ -147,5 +147,5 @@
 	while( u )
 	{
-		if( u->gc == gc && u->handle && gc->acc->prpl->cmp_buddynames ( u->handle, handle ) == 0 )
+		if( u->gc == gc && u->handle && gc->prpl->cmp_buddynames ( u->handle, handle ) == 0 )
 			break;
 		u = u->next;
Index: util.c
===================================================================
--- util.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
+++ util.c	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -0,0 +1,494 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/*
+ * Various utility functions. Some are copied from Gaim to support the
+ * IM-modules, most are from BitlBee.
+ *
+ * Copyright (C) 1998-1999, Mark Spencer <markster@marko.net>
+ *                          (and possibly other members of the Gaim team)
+ * Copyright 2002-2005 Wilmer van der Gaast <wilmer@gaast.net>
+ */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#define BITLBEE_CORE
+#include "nogaim.h"
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <ctype.h>
+#include <glib.h>
+#include <time.h>
+
+void strip_linefeed(gchar *text)
+{
+	int i, j;
+	gchar *text2 = g_malloc(strlen(text) + 1);
+
+	for (i = 0, j = 0; text[i]; i++)
+		if (text[i] != '\r')
+			text2[j++] = text[i];
+	text2[j] = '\0';
+
+	strcpy(text, text2);
+	g_free(text2);
+}
+
+char *add_cr(char *text)
+{
+	char *ret = NULL;
+	int count = 0, j;
+	unsigned int i;
+
+	if (text[0] == '\n')
+		count++;
+	for (i = 1; i < strlen(text); i++)
+		if (text[i] == '\n' && text[i - 1] != '\r')
+			count++;
+
+	if (count == 0)
+		return g_strdup(text);
+
+	ret = g_malloc0(strlen(text) + count + 1);
+
+	i = 0; j = 0;
+	if (text[i] == '\n')
+		ret[j++] = '\r';
+	ret[j++] = text[i++];
+	for (; i < strlen(text); i++) {
+		if (text[i] == '\n' && text[i - 1] != '\r')
+			ret[j++] = '\r';
+		ret[j++] = text[i];
+	}
+
+	return ret;
+}
+
+static char alphabet[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz" "0123456789+/";
+
+/* XXX Find bug */
+char *tobase64(const char *text)
+{
+	char *out = NULL;
+	const char *c;
+	unsigned int tmp = 0;
+	int len = 0, n = 0;
+
+	c = text;
+
+	while (*c) {
+		tmp = tmp << 8;
+		tmp += *c;
+		n++;
+
+		if (n == 3) {
+			out = g_realloc(out, len + 4);
+			out[len] = alphabet[(tmp >> 18) & 0x3f];
+			out[len + 1] = alphabet[(tmp >> 12) & 0x3f];
+			out[len + 2] = alphabet[(tmp >> 6) & 0x3f];
+			out[len + 3] = alphabet[tmp & 0x3f];
+			len += 4;
+			tmp = 0;
+			n = 0;
+		}
+		c++;
+	}
+	switch (n) {
+
+	case 2:
+		tmp <<= 8;
+		out = g_realloc(out, len + 5);
+		out[len] = alphabet[(tmp >> 18) & 0x3f];
+		out[len + 1] = alphabet[(tmp >> 12) & 0x3f];
+		out[len + 2] = alphabet[(tmp >> 6) & 0x3f];
+		out[len + 3] = '=';
+		out[len + 4] = 0;
+		break;
+	case 1:
+		tmp <<= 16;
+		out = g_realloc(out, len + 5);
+		out[len] = alphabet[(tmp >> 18) & 0x3f];
+		out[len + 1] = alphabet[(tmp >> 12) & 0x3f];
+		out[len + 2] = '=';
+		out[len + 3] = '=';
+		out[len + 4] = 0;
+		break;
+	case 0:
+		out = g_realloc(out, len + 1);
+		out[len] = 0;
+		break;
+	}
+	return out;
+}
+
+char *normalize(const char *s)
+{
+	static char buf[BUF_LEN];
+	char *t, *u;
+	int x = 0;
+
+	g_return_val_if_fail((s != NULL), NULL);
+
+	u = t = g_strdup(s);
+
+	strcpy(t, s);
+	g_strdown(t);
+
+	while (*t && (x < BUF_LEN - 1)) {
+		if (*t != ' ') {
+			buf[x] = *t;
+			x++;
+		}
+		t++;
+	}
+	buf[x] = '\0';
+	g_free(u);
+	return buf;
+}
+
+time_t get_time(int year, int month, int day, int hour, int min, int sec)
+{
+	struct tm tm;
+
+	tm.tm_year = year - 1900;
+	tm.tm_mon = month - 1;
+	tm.tm_mday = day;
+	tm.tm_hour = hour;
+	tm.tm_min = min;
+	tm.tm_sec = sec >= 0 ? sec : time(NULL) % 60;
+	return mktime(&tm);
+}
+
+typedef struct htmlentity
+{
+	char code[8];
+	char is[4];
+} htmlentity_t;
+
+/* FIXME: This is ISO8859-1(5) centric, so might cause problems with other charsets. */
+
+static const htmlentity_t ent[] =
+{
+	{ "lt",     "<" },
+	{ "gt",     ">" },
+	{ "amp",    "&" },
+	{ "quot",   "\"" },
+	{ "aacute", "á" },
+	{ "eacute", "é" },
+	{ "iacute", "é" },
+	{ "oacute", "ó" },
+	{ "uacute", "ú" },
+	{ "agrave", "à" },
+	{ "egrave", "è" },
+	{ "igrave", "ì" },
+	{ "ograve", "ò" },
+	{ "ugrave", "ù" },
+	{ "acirc",  "â" },
+	{ "ecirc",  "ê" },
+	{ "icirc",  "î" },
+	{ "ocirc",  "ô" },
+	{ "ucirc",  "û" },
+	{ "auml",   "ä" },
+	{ "euml",   "ë" },
+	{ "iuml",   "ï" },
+	{ "ouml",   "ö" },
+	{ "uuml",   "ü" },
+	{ "nbsp",   " " },
+	{ "",        ""  }
+};
+
+void strip_html( char *in )
+{
+	char *start = in;
+	char *out = g_malloc( strlen( in ) + 1 );
+	char *s = out, *cs;
+	int i, matched;
+	
+	memset( out, 0, strlen( in ) + 1 );
+	
+	while( *in )
+	{
+		if( *in == '<' && ( isalpha( *(in+1) ) || *(in+1) == '/' ) )
+		{
+			/* If in points at a < and in+1 points at a letter or a slash, this is probably
+			   a HTML-tag. Try to find a closing > and continue there. If the > can't be
+			   found, assume that it wasn't a HTML-tag after all. */
+			
+			cs = in;
+			
+			while( *in && *in != '>' )
+				in ++;
+			
+			if( *in )
+			{
+				if( g_strncasecmp( cs+1, "br", 2) == 0 )
+					*(s++) = '\n';
+				in ++;
+			}
+			else
+			{
+				in = cs;
+				*(s++) = *(in++);
+			}
+		}
+		else if( *in == '&' )
+		{
+			cs = ++in;
+			while( *in && isalpha( *in ) )
+				in ++;
+			
+			if( *in == ';' ) in ++;
+			matched = 0;
+			
+			for( i = 0; *ent[i].code; i ++ )
+				if( g_strncasecmp( ent[i].code, cs, strlen( ent[i].code ) ) == 0 )
+				{
+					int j;
+					
+					for( j = 0; ent[i].is[j]; j ++ )
+						*(s++) = ent[i].is[j];
+					
+					matched = 1;
+					break;
+				}
+
+			/* None of the entities were matched, so return the string */
+			if( !matched )
+			{
+				in = cs - 1;
+				*(s++) = *(in++);
+			}
+		}
+		else
+		{
+			*(s++) = *(in++);
+		}
+	}
+	
+	strcpy( start, out );
+	g_free( out );
+}
+
+char *escape_html( const char *html )
+{
+	const char *c = html;
+	GString *ret;
+	char *str;
+	
+	if( html == NULL )
+		return( NULL );
+	
+	ret = g_string_new( "" );
+	
+	while( *c )
+	{
+		switch( *c )
+		{
+			case '&':
+				ret = g_string_append( ret, "&amp;" );
+				break;
+			case '<':
+				ret = g_string_append( ret, "&lt;" );
+				break;
+			case '>':
+				ret = g_string_append( ret, "&gt;" );
+				break;
+			case '"':
+				ret = g_string_append( ret, "&quot;" );
+				break;
+			default:
+				ret = g_string_append_c( ret, *c );
+		}
+		c ++;
+	}
+	
+	str = ret->str;
+	g_string_free( ret, FALSE );
+	return( str );
+}
+
+void info_string_append(GString *str, char *newline, char *name, char *value)
+{
+	if( value && value[0] )
+		g_string_sprintfa( str, "%s%s: %s", newline, name, value );
+}
+
+/* Decode%20a%20file%20name						*/
+void http_decode( char *s )
+{
+	char *t;
+	int i, j, k;
+	
+	t = g_new( char, strlen( s ) + 1 );
+	
+	for( i = j = 0; s[i]; i ++, j ++ )
+	{
+		if( s[i] == '%' )
+		{
+			if( sscanf( s + i + 1, "%2x", &k ) )
+			{
+				t[j] = k;
+				i += 2;
+			}
+			else
+			{
+				*t = 0;
+				break;
+			}
+		}
+		else
+		{
+			t[j] = s[i];
+		}
+	}
+	t[j] = 0;
+	
+	strcpy( s, t );
+	g_free( t );
+}
+
+/* Warning: This one explodes the string. Worst-cases can make the string 3x its original size! */
+/* This fuction is safe, but make sure you call it safely as well! */
+void http_encode( char *s )
+{
+	char *t;
+	int i, j;
+	
+	t = g_strdup( s );
+	
+	for( i = j = 0; t[i]; i ++, j ++ )
+	{
+		/* if( t[i] <= ' ' || ((unsigned char *)t)[i] >= 128 || t[i] == '%' ) */
+		if( !isalnum( t[i] ) )
+		{
+			sprintf( s + j, "%%%02X", ((unsigned char*)t)[i] );
+			j += 2;
+		}
+		else
+		{
+			s[j] = t[i];
+		}
+	}
+	s[j] = 0;
+	
+	g_free( t );
+}
+
+/* Strip newlines from a string. Modifies the string passed to it. */ 
+char *strip_newlines( char *source )
+{
+	int i;	
+
+	for( i = 0; source[i] != '\0'; i ++ )
+		if( source[i] == '\n' || source[i] == '\r' )
+			source[i] = ' ';
+	
+	return source;
+}
+
+#ifdef IPV6
+/* Wrap an IPv4 address into IPv6 space. Not thread-safe... */
+char *ipv6_wrap( char *src )
+{
+	static char dst[64];
+	int i;
+	
+	for( i = 0; src[i]; i ++ )
+		if( ( src[i] < '0' || src[i] > '9' ) && src[i] != '.' )
+			break;
+	
+	/* Hmm, it's not even an IP... */
+	if( src[i] )
+		return src;
+	
+	g_snprintf( dst, sizeof( dst ), "::ffff:%s", src );
+	
+	return dst;
+}
+
+/* Unwrap an IPv4 address into IPv6 space. Thread-safe, because it's very simple. :-) */
+char *ipv6_unwrap( char *src )
+{
+	int i;
+	
+	if( g_strncasecmp( src, "::ffff:", 7 ) != 0 )
+		return src;
+	
+	for( i = 7; src[i]; i ++ )
+		if( ( src[i] < '0' || src[i] > '9' ) && src[i] != '.' )
+			break;
+	
+	/* Hmm, it's not even an IP... */
+	if( src[i] )
+		return src;
+	
+	return ( src + 7 );
+}
+#endif
+
+/* Convert from one charset to another.
+   
+   from_cs, to_cs: Source and destination charsets
+   src, dst: Source and destination strings
+   size: Size if src. 0 == use strlen(). strlen() is not reliable for UNICODE/UTF16 strings though.
+   maxbuf: Maximum number of bytes to write to dst
+   
+   Returns the number of bytes written to maxbuf or -1 on an error.
+*/
+signed int do_iconv( char *from_cs, char *to_cs, char *src, char *dst, size_t size, size_t maxbuf )
+{
+	GIConv cd;
+	size_t res;
+	size_t inbytesleft, outbytesleft;
+	char *inbuf = src;
+	char *outbuf = dst;
+	
+	cd = g_iconv_open( to_cs, from_cs );
+	if( cd == (GIConv) -1 )
+		return( -1 );
+	
+	inbytesleft = size ? size : strlen( src );
+	outbytesleft = maxbuf - 1;
+	res = g_iconv( cd, &inbuf, &inbytesleft, &outbuf, &outbytesleft );
+	*outbuf = '\0';
+	g_iconv_close( cd );
+	
+	if( res == (size_t) -1 )
+		return( -1 );
+	else
+		return( outbuf - dst );
+}
+
+char *set_eval_charset( irc_t *irc, set_t *set, char *value )
+{
+	GIConv cd;
+
+	if ( g_strncasecmp( value, "none", 4 ) == 0 )
+		return( value );
+
+	cd = g_iconv_open( "UTF-8", value );
+	if( cd == (GIConv) -1 )
+		return( NULL );
+
+	g_iconv_close( cd );
+	return( value );
+}
Index: util.h
===================================================================
--- util.h	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
+++ util.h	(revision 3f9440db856c1b1cde54eb919543cfc23ea09983)
@@ -0,0 +1,50 @@
+  /********************************************************************\
+  * BitlBee -- An IRC to other IM-networks gateway                     *
+  *                                                                    *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
+  \********************************************************************/
+
+/* Misc. functions                                                      */
+
+/*
+  This program is free software; you can redistribute it and/or modify
+  it under the terms of the GNU General Public License as published by
+  the Free Software Foundation; either version 2 of the License, or
+  (at your option) any later version.
+
+  This program is distributed in the hope that it will be useful,
+  but WITHOUT ANY WARRANTY; without even the implied warranty of
+  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+  GNU General Public License for more details.
+
+  You should have received a copy of the GNU General Public License with
+  the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
+*/
+
+#ifndef _UTIL_H
+#define _UTIL_H
+
+G_MODULE_EXPORT void strip_linefeed( gchar *text );
+G_MODULE_EXPORT char *add_cr( char *text );
+G_MODULE_EXPORT char *strip_newlines(char *source);
+G_MODULE_EXPORT char *tobase64( const char *text );
+G_MODULE_EXPORT char *normalize( const char *s );
+G_MODULE_EXPORT void info_string_append( GString *str, char *newline, char *name, char *value );
+
+G_MODULE_EXPORT time_t get_time( int year, int month, int day, int hour, int min, int sec );
+double gettime( void );
+
+G_MODULE_EXPORT void strip_html( char *msg );
+G_MODULE_EXPORT char *escape_html( const char *html );
+G_MODULE_EXPORT void http_decode( char *s );
+G_MODULE_EXPORT void http_encode( char *s );
+
+G_MODULE_EXPORT char *ipv6_wrap( char *src );
+G_MODULE_EXPORT char *ipv6_unwrap( char *src );
+
+G_MODULE_EXPORT signed int do_iconv( char *from_cs, char *to_cs, char *src, char *dst, size_t size, size_t maxbuf );
+char *set_eval_charset( irc_t *irc, set_t *set, char *value );
+
+#endif
